#ifndef __VECTOR_H__
#define __VECTOR_H__

typedef struct
{
	size_t cSpaceAlloced;
	size_t nAlloced;
	size_t cElemSize;
	size_t nUsed;
} VECTORHEAD, *LPVECTORHEAD;


LPVECTORHEAD VectorCreate(size_t cElemSize);
BOOL VectorDelete(LPVECTORHEAD *p);
BOOL VectorIsEmpty(LPVECTORHEAD p);
size_t VectorSize(LPVECTORHEAD p);
size_t VectorCapacity(LPVECTORHEAD p);
void *VectorBack(LPVECTORHEAD p);
void *VectorAt(LPVECTORHEAD p, size_t n);
void *VectorData(LPVECTORHEAD p);
BOOL VectorPopBack(LPVECTORHEAD p);
BOOL VectorPushBack(LPVECTORHEAD *p, void *pData);
BOOL VectorClear(LPVECTORHEAD *p);
BOOL VectorErase(LPVECTORHEAD *p, size_t first, size_t last);
BOOL VectorInsert(LPVECTORHEAD *p, size_t position, size_t n, void *pData);

#define DECL_VECTOR(name, type) typedef struct {VECTORHEAD; type Data[];} Vect_##name, *name;	\
								BOOL   __forceinline name##_IsEmpty(name p)						\
													{return VectorIsEmpty((LPVECTORHEAD)p);}						\
								size_t __forceinline name##_Size(name p)							\
													{return VectorSize((LPVECTORHEAD)p);}							\
								type   __forceinline *name##_Back(name p)							\
													{return VectorBack((LPVECTORHEAD)p);}							\
								BOOL   __forceinline name##_PopBack(name p)						\
													{return VectorPopBack((LPVECTORHEAD)p);}						\
								BOOL   __forceinline name##_PushBack(name *p, type *pData)			\
													{return VectorPushBack((LPVECTORHEAD *)p, pData);}	\
								BOOL   __forceinline name##_Clear(name *p)							\
													{return VectorClear((LPVECTORHEAD *)p);}				\
								type   __forceinline *name##_Data(name p)	\
													{return VectorData((LPVECTORHEAD) p);}				\
								BOOL   __forceinline name##_Delete(name *p)						\
													{return VectorDelete((LPVECTORHEAD *)p);}				\
								name   __forceinline name##_Create(void * Reserved)							\
													{return (name) VectorCreate(sizeof(type));}

#define Vector(fn, type, ...)  type##_##fn(__VA_ARGS__)
#endif	// __VECTOR_H__
